#!/usr/bin/python
'''Forumotion to phpBB 3 Converter by nneonneo
Based on the Invisionfree converter
Version 0.2.8
Topics and Posts Part
Mar 29 2008
Updated Apr 16 2009'''
import os,re,urllib2,sys,random,md5,cgi
from time import strftime,strptime,mktime,time,localtime
from binascii import crc32 # for email hash
try:
    from settings import *
except Exception, detail:
    print "Error: Settings file has some error."
    print "Details of the error:"
    sys.excepthook(*sys.exc_info())
    raw_input("Press <enter> to quit.")
    sys.exit(1)
sys.path.append('..')
from common import *

# Don't edit this file, unless you are SURE you know what you are doing.
topics_max_group = 500
posts_max_group = 200
members_max_group = 500
beg_time=time()
img_locked='<img src="%s" class="i_reply" '%lockimage
re_pages=re.compile('<div class="pagination">Page <strong>1</strong> of <strong>(\\d+)</strong>') # page detection
re_forum_pages=re.compile('Page <strong>1</strong> of <strong>(\\d+)</strong>') # page detection on forum pages
re_topicviews=re.compile('<a class="topictitle" href="/[^/"]*?/[^/"]*?-t(\\d+)\\.htm">.*?<dd class="views">([\\d,]+) <dfn>Views</dfn>')
# the massive grep list of doom!
# the grep list works by changing certain things to delimited, structured data. The delimiters are "<^>" at the start and "</^>" at the end of a record, and the fields are separated with "<|>".
# first one: detection of the exact forum we're in
repstrings=[("""<a href="/[^"]+?-f(\\d+)/" class="nav">[^<]+</a></p></div>""","""<^>FORUM<|>\\1</^>"""),
# detect the title of the topic
("""<title>(.+?)</title>""","""<^>TITLE<|>\\1</^>"""),
# re hack: replace "unreg" with a registered user, id 0. RE doesn't work right :(
("""</dt><dd>Guest<br /></dd><dd><br /></dd><dd>""","""</dt><dd>Guest<br /></dd><li><a href="/profile.forum?mode=viewprofile&amp;u=0">"""),
#'''   0      1         2         3           4           5      6      7           8           9            10             '''
#'''<^>POST<|>Post ID<|>User ID<|>User Name<|>Date/Time<|>Text<|>EDIT<|>Edit Name<|>Edit Time<|>Edit Count<|>Edit Reason</^>'''
# !!! the big one: get the entire post
("""((?:[^ ]+ at |\\d+-\\d+-\\d+, )\\d+:\\d+)</p>.*<!--\\n google_ad_section_start -->(.+)<!--\\n google_ad_section_end --></div>(?:<div id="[^"]+" class="signature">.+?</div>)?(.*?)(?:<div id="[^"]+" class="signature">.+?</div>)?</div><(?:dl|div) class="postprofile" id="profile(\\d+)">(?:.|<!--\\n div)*?<strong style="font-size: 1.2em;">(?:<a[^>]*>)?(.+?)(?:</a>)?</strong></dt>.+?<a href="/profile.forum\\?mode=viewprofile&amp;u=(\\d+)\"""","""<^>POST<|>\\4<|>\\6<|>\\5<|>\\1<|>\\2<^EDIT^>\\3</^>"""),
# edit info
("""<\\^EDIT\\^></\\^>""","""</^>"""),
(""" \\(Reason for editing : (.*?)\\)</\\^>""","""\\1</^>"""),
("""<\\^EDIT\\^><br[^>]*><br[^>]*>Last edited by (.*?) on (.*?); edited (\\d+) times? in total(.*?)</\\^>""","""<|>EDIT<|>\\1<|>\\2<|>\\3<|>\\4</^>"""),
# add a "<^>" tag to the end of the file - acts like the start of a tag
("""\\Z""","""<^>"""),
# and a "</^>" tag to the beginning - like the end of a tag
("""\\A""","""</^>"""),
# delete everything between the tags (blank space) leaving only the tags
("""</\\^>[\\w\\W]*?<\\^>""","""</^><^>"""),
# kill duplicate data from subsequent pages
("""POST<\\|>(.+)\\nTITLE<\\|>.+""","""POST<|>\\1"""),
# destroy any blank lines
("""^\\n""",""""""),
# and remove the blank line at the end.
("""\\n\\Z""","""""")]
# BBCode-only repstrings; these will be run exclusively on post text
bbcode_repstrings=[
# convert image links
("""<img src="([^"]+)" alt="" />""","[img:<UID>]\\1[/img:<UID>]"),
# emotes (convert to straight images)
("""<img src="([^"]+)" alt="[^"]+" smilieid="[^"]+" />""","[img:<UID>]\\1[/img:<UID>]"),
# code tags
("""<dl class="codebox"><dt>Code:</dt><dd><code>""","[code:<UID>]"),
("""</code></dd></dl>""","""[/code:<UID>]"""),
# quotes: anything else (phpBB only supports author argument)
("""<blockquote><div><cite>(.+?) wrote:</cite>""","[quote=&quot;\\1&quot;:<UID>]"),
# quotes: no author
("""<blockquote><div>""","[quote:<UID>]"),
# quotes: closing
("""</div></blockquote>""","[/quote:<UID>]"),
# b,i,u tags
("<(/?[biu])>","[\\1:<UID>]"),
("<(/?)strong>","[\\1b:<UID>]"),
# [s] tags, not supported by phpBB3
("<span><strike>|</strike></span>",""),
# emails (phpBB autoparses valid emails)
("""<a href="mailto:([^"]+?)">(?:<u>)?(.+?)(?:</u>)?</a>""","""[email:<UID>]\\1[/email:<UID>]"""),
# convert URL links
("""<a href="([^"]+?)"[^>]*?>(?:<u>)?(.+?)(?:</u>)?</a>""","""[url=\\1:<UID>]\\2[/url:<UID>]"""),
# list tags
("<ol type=['\"]([1aAiI])['\"]>","[list=\\1:<UID>]"),
("<ul>","[list:<UID>]"), # unordered
("</ol>","[/list:o:<UID>]"), # closing tag
("</ul>","[/list:u:<UID>]"), # closing tag
("<li/>(.+?)<","[*:<UID>]\\1[/*:m:<UID>]<"),
("<li>","[*:<UID>]"), # list item
("</li>","[/*:m:<UID>]"), # end tag not required
# font formatting
("""<span style="font-size: (\\d+)px; line-height: normal">""",lambda m:"[size=%i:<UID>]"%(100*int(m.group(1))/12)),
("</span>","[/size:<UID>]"),
# flash
("""<embed pluginspage="http://www.macromedia.com/go/getflashplayer" src="(.+?)" width="(.+?)" height="(.+?)" type="application/x-shockwave-flash" wmode="transparent" quality="high" scale="exactfit"></embed>""","""[flash=\\2,\\3:<UID>]\\1[/flash:<UID>]"""),]

re_repstrings=[(re.compile(a),b) for a,b in repstrings]
re_bbcode=[(re.compile(a),b) for a,b in bbcode_repstrings]

def parsetime(tm,fmt='%Y-%m-%d, %H:%M'): # glorious time parser, returns the UNIX time-since-epoch-in-seconds thing ;)
    return mktime(
        strptime(
            tm.replace("Sept","Sep").
                           replace("<b>Today</b> at ",strftime('%Y-%m-%d, ')).
                           replace("[b]Today[/b] at ",strftime('%Y-%m-%d, ')).
                           replace("Today at ",strftime('%Y-%m-%d, ')).
                           replace("Yesterday at ",strftime('%Y-%m-%d, ',localtime(time()-24*3600)))
            ,fmt)
        )

def parsespans(dat):
    # copied from IF converter and repurposed for font tags :P
    sb="<font"
    se='</font>'
    begin_off=dat.find(sb)
    if begin_off==-1: return dat # no spans!
    out=dat[:begin_off] # data right up to the span
    rest=dat[begin_off+len(sb):] # the remainder, after the sb block
    lwrrest=rest.lower()
    if lwrrest.startswith(' color="'):
        type="color"
        tagparams=rest[len(' color="'):].split('"')[0]
        starttag='[color=%s:<UID>]'%tagparams
        endtag='[/color:<UID>]'
    else:
        starttag=endtag=type=''
    spandata=starttag
    se_off=rest.find(">") # nearest span ending
    if se_off==-1:
        print "Warning: Invalid <font> found!!"
        return dat
    rest=rest[se_off+1:] # what's after the > ?
    text=rest
    nestlevel=1 # nesting level: we're inside one span
    while nestlevel:
        se_off=rest.find(se) # where's the </span>
        sb_off=rest.find(sb) # or another <span
        if se_off==-1: 
            print "Warning: No </span> found!!"
            return dat
        if sb_off==-1 or se_off<sb_off: # no new beginning (sb) before the se? good news!
            nestlevel-=1
            rest=rest[se_off+len(se):]
            continue
        elif sb_off!=-1 and sb_off<se_off: # a new beginning? darn. process it. new beginning must be before the end.
            rest=rest[sb_off+len(sb):] 
            nestlevel+=1 # increase nesting level, we won't actually process it, this just helps us find the exact block of this span
            continue
    spandata+=parsespans(text[:-(len(rest)+len(se))])+endtag # gotcha! the end of the span. Now, process the innards for nested spans.
    spandata+=parsespans(rest) # parse the rest
    return out+spandata

def makebitfield(dat):
    bbcodes={'code':8,
             'quote':0,
             'attachment':12,
             'b':1,
             'i':2,
             'url':3,
             'img':4,
             'size':5,
             'color':6,
             'u':7,
             'list':9,
             'email':10,
             'flash':11}
    bf=[0]*10
    for i in bbcodes:
        if re.findall('\\[/'+i+':[^\\[\\]]*<UID>]', dat):
            c,d=divmod(bbcodes[i],8)
            bf[c]|=(1<<(7-d))
    return ''.join([chr(c) for c in bf]).rstrip('\0').encode('base64')


''' This section will download each individual member page and process it, extracting
all the visible profile data. Members will then be renumbered according to join date
so that the member order matches the order obtained if they had signed up in phpBB.'''

print "Downloading Members..."
out=open('members_phpBB3.sql','w')
out.write('DELETE FROM '+table_prefix+'users;'+'DELETE FROM '+table_prefix+'user_group;'+'INSERT INTO '+table_prefix+'''users (user_id, user_type, group_id, username, username_clean, user_regdate, user_password, user_email, user_lang, user_style, user_rank, user_colour, user_posts, user_permissions, user_ip, user_birthday, user_lastpage, user_last_confirm_key, user_post_sortby_type, user_post_sortby_dir, user_topic_sortby_type, user_topic_sortby_dir, user_avatar, user_sig, user_sig_bbcode_uid, user_from, user_icq, user_aim, user_yim, user_msnm, user_jabber, user_website, user_occ, user_interests, user_actkey, user_newpasswd, user_allow_massemail) VALUES (1, 2, 1, 'Anonymous', 'anonymous', 0, '', '', 'en', 1, 0, '', 0, '', '', '', '', '', 't', 'a', 't', 'd', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 0);INSERT INTO '''+table_prefix+'''user_group (group_id, user_id, user_pending) VALUES('1', '1', '0');''')
PM_data=open('pm_passwords.txt','w')
memberdata=[]
memberslist={}
for memberid in range(1,NUMUSERS+1):
    try:
        random.seed(RANDOMNUMBER+hash(memberid)) # creates static member passwords: they will never change.
        statusline="Member %s ... "%memberid
        userdata=download_page(URL+'profile.forum?mode=viewprofile&u='+str(memberid),statusline+"Downloading - ",COOKIEDATA)
        p=re.findall("""<dt>(?:<span[^>]*>)?([^<>\\n]+?)(?:</span>)?: ?(?:&nbsp;)?</dt> ?<dd>(?:<span class="field_uneditable">)?(.+?)(?:</span>|</dd>)""", userdata) # locate all "quick info" lines
        if not p: # oops, no profile lines found
            print "Warning: Member %s doesn't exist!"%memberid
            continue
        """
        Indices of "dat" mapped to phpBB phpbb_users columns
        0:user_id
        1:username
        2:[realName]
        3:user_email
        4:[websiteTitle]
        5:user_website
        6:user_birthday
        7:[gender]
        8:user_from
        9:user_posts
        10:[karmaGood] <-- warning, could be negative; I wonder how that's handled?
        11:user_regdate
        12:user_icq
        13:user_aim
        14:user_yim
        15:user_msnm
        16:user_lastvisit
        17:user_password
        18:user_avatar
        19:user_level
        20:[ID_POST_GROUP]
        21:user_occ
        22:user_interests
        """
        dat=[memberid+1,'','','','','',' 0- 0-   0',0,'',0,0,0,'','','','',0,'','',0,0,'','']
        dat[1]=dat[2]=(re.findall('<h[^>]*>Viewing profile :: (.+?)</h',userdata) or [''])[0]
        dat[1]=re.sub('<[^>]*>','',dat[1]) # strip tags
        dat[18]=(re.findall('<img src="([^"]+?)" alt="\\[avatar\\]" border="0".*?/>',userdata) or [''])[0]

        for t,i in p:
            try:
                t=t.strip(':')
                i=i.strip()
                if i in ['&nbsp;','&nbsp;-']: continue
                if t=='Avatar':
                    av=(re.findall('<img src="(.+?)"',i) or [''])[0]
                    if av.startswith('/'):
                        dat[18]=URL+av[1:]
                    else:
                        dat[18]=av
                elif t=='Rank':
                    if i.startswith('<strong>Admin'):
                        dat[19]=3
                elif t=='Status': pass
                elif t=='Administrate user':
                    url=re.findall("""<a href="([^"]*)">Profile</a>""",i)[0].replace('&amp;','&')
                    data=download_page(URL+url,statusline+"Retrieving e-mail address...",COOKIEDATA)
                    found=re.findall("""<input[^>]*name="email"[^>]*value="([^"]*)\"""",data)
                    if not found:
                        raise Exception("Please log in to your administration panel and update the cookie in order to download member e-mails.")
                    dat[3]=found[0]
                elif t=='Location': dat[8]=i
                elif t=='Birthday':
                    date=(re.findall("""<span style="vertical-align: top;">(.+?)&nbsp;.+</span>""",i) or [i])[0]
                    if date != "None Specified":
                        dat[6]=strftime('%d-%m-%Y',strptime(date,PROFILE_DATEFMT))
                elif t=='Gender':
                    if 'Male' in i:
                        dat[7]=1
                    elif 'Female' in i:
                        dat[7]=2
                elif t=='Job/hobbies': dat[21]=i
                elif t=='Humor': dat[22]=i
                elif t=='Send an email': dat[3]=(re.findall('<a href="mailto:(.+?)">',i) or [dat[3]])[0]
                elif t=='Website':
                    dat[5]=re.findall("""<a href="([^"]+)\"""",i)[0]
                    dat[4]='Website'
                elif t=='Private Message': pass
                elif t=='MSN Messenger':
                    dat[15]=re.findall("""<a href="msnim:chat\\?contact=(.+?)\"""",i)[0]
                    dat[15]=re.sub('&#(\\d+);',lambda match: chr(int(match.group(1))), dat[15])
                elif t=='Yahoo Messenger': dat[14]=re.findall("""<a href="http://edit.yahoo.com/config/send_webmesg\\?.target=(.+?)&amp;.src=pg\"""",i)[0]
                elif t=='AIM Address': dat[13]=re.findall("""<a href="aim:goim\\?screenname=(.+?)\"""",i)[0]
                elif t=='ICQ Number': dat[12]=re.findall("""<a href="http://www.icq.com/people/about_me.php\\?to=(.+?)\"""",i)[0]
                elif t=='Skype': pass
                elif t in ['Joined', 'Join date', 'Registration date']: dat[11]=parsetime(i,PROFILE_DATEFMT)
                elif t=='Last visit':
                    if i!='Never':
                        dat[16]=parsetime(i)
                elif t=='Private messages': pass
                elif t in ['Posts', 'Total posts', 'Number of posts']: dat[9]=int((re.findall("<strong>(\\d+)</strong>",i) or [i])[0])
                elif t=='Friends and foes': pass
                elif t=='Zodiac': pass
                elif t=='Chinese zodiac': pass
                elif t=='Age': pass
                elif t=='Points': pass
                elif t=='Reputation': pass
                else:
                    print # blank line; prevent overwrite
                    print "\tUnknown field %s, data %s"%(t,i)
            except ValueError,detail:
                print # blank line to prevent overwrite
                print "\tError:",detail
        memberslist[dat[1]]=dat[0]
        printline(statusline+"Processing")
        passnumber=str(random.randint(0,0xffffff))
        dat[17]=md5.new(passnumber).hexdigest() # phpBB uses md5 for password hashing
        #dat[20]=postgroup(dat[9]) # compute post group AFTER we've got the posts
        memberdata+=[dat]
        PM_data.write("%s|%s\n"%(dat[1],passnumber))
        printline(statusline+"Completed! User Password: %s"%passnumber)
        print # blank line for next member
    except KeyboardInterrupt: break # abort processing, write out data now
    except Exception:
        do_except('Member ID %s'%memberid, statusline)
memberdata=[escape_vars(i) for i in memberdata]
for i in range(0,len(memberdata),members_max_group):
    # n.b. username _could_ be their display name, but then user sorting gets broken :'(
    out.write("INSERT INTO "+table_prefix+"users(user_id, user_type, group_id, username, username_clean, user_regdate, user_password, user_email, user_email_hash, user_lang, user_style, user_rank, user_colour, user_posts, user_permissions, user_ip, user_birthday, user_lastpage, user_last_confirm_key, user_post_sortby_type, user_post_sortby_dir, user_topic_sortby_type, user_topic_sortby_dir, user_avatar, user_sig, user_sig_bbcode_uid, user_from, user_icq, user_aim, user_yim, user_msnm, user_jabber, user_lastvisit, user_website, user_occ, user_interests, user_actkey, user_newpasswd, user_pass_convert, user_avatar_type) VALUES ")
    out.write(','.join(["(%i, %i, %i, '%s', '%s', %i, '%s', '%s', '%s', 'en', 1, %i, '%s', %i, '', '', '%s', '', '', 't', 'a', 't', 'd', '%s', '', '', '%s', '%s', '%s', '%s', '%s', '', %i, '%s', '%s', '%s', '', '', 1, 2)" %(dat[0],dat[19],5 if dat[19] else 2,dat[1],dat[1].lower(),dat[11],dat[17],dat[3],str(crc32(dat[3]))+str(len(dat[3])),1 if dat[19] else 0,'AA0000' if dat[19] else '',dat[9],dat[6],dat[18],dat[8],dat[12],dat[13],dat[14],dat[15],dat[16],dat[5],dat[21],dat[22])  for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending) VALUES ")
    out.write(','.join(["('2', '%i', '0')"%dat[0] for dat in memberdata[i:i+members_max_group]]))
    out.write(";\n")
    for dat in memberdata[i:i+members_max_group]:
        if dat[19]==3: # admin
            out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending, group_leader) VALUES (4, %i, 0, 0);\n"%dat[0])
            out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending, group_leader) VALUES (5, %i, 0, 1);\n"%dat[0])
PM_data.close()
out.close()


topicviews={}
BOARDS={}
SEEN=set()
print "Downloading Forum Structure..."
out=open("categories_forums_phpBB3.sql","w")
out.write('DELETE FROM '+table_prefix+'forums;\nDELETE FROM '+table_prefix+'acl_groups WHERE forum_id > 0;\n')
re_forums='''<li class="row"><dl.*?><d(?:t|d class="dterm")><[^>]*>(?:<h[^>]* class="hierarchy">)?<a href="/[^"]*-([cf]\\d+)/" class="forumtitle">(.+?)</a>(?:</h[^>]*>)?<br />(.*?)(?:<strong></strong>|<span class="mod-text">|<br />)'''

def dl_cvt_subforum(fid, left, parent, name, desc):
    ''' recursively download and convert subforums '''
    global statusline
    if fid in SEEN:
        return left-1
    SEEN.add(fid)
    if fid[0]=='f':
        BOARDS[int(fid[1:])]=left
    curleft=left+1
    statusline="Forum %s ... "%fid
    progressline=statusline+"Downloading - "
    if fid=='c0': u='index.htm'
    else: u='forum-%s'%fid
    forumdata = download_page(URL+u, progressline, COOKIEDATA)
    pagedata=forumdata
    pages=re.findall(re_forum_pages,pagedata)
    if pages and pages[0]!='1':
        np=int(pages[0])
        perpage=int(re.findall('-%s-(\\d+)\\.htm">2</a>'%fid,pagedata)[0])
        for offset in range(1,np):
            progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
            pagedata+=download_page(URL+'-%s-%i.htm'%(fid,offset*perpage),progressline,COOKIEDATA)
    for tid,v in re.findall(re_topicviews,pagedata):
        topicviews[int(tid)]=int(v.replace(',',''))
    subforums = re.findall(re_forums, forumdata)
    for sfid, sname, sdesc in subforums:
        curleft=dl_cvt_subforum(sfid, curleft, left, sname, sdesc)+1
    out.write('INSERT INTO '+table_prefix+'forums (forum_id, parent_id, left_id, right_id, forum_name, forum_desc, forum_type) VALUES (%i, %i, %i, %i, \'%s\', \'%s\', %i);\n'%((left, parent, left, curleft, escape_var(name), escape_var(desc), int(fid[0]=='f'))))
    out.write(phpbb3_default_forum_acl(table_prefix, left))
    return curleft

try:
    dl_cvt_subforum('c0', 1, 0, 'Forum', '')
    out.close()
    printline(statusline+"Completed!")
    print
except Exception:
    do_except("Categories and Forums", statusline)

postid=1
topicdata,postdata=[],[]
block_size=4096
forum_stats={} # topics, posts, latest_post_id, latest_post_time; this will store forum stats so we can update the DB with that information.
for topicid in topicviews:
    try:
        statusline="Topic ID %i ... "%topicid
        progressline=statusline+"Downloading - "
        pagedata=download_page(URL+'-t%i.htm'%topicid,progressline,COOKIEDATA)
        pages=re.findall(re_pages,pagedata)
        if pages and pages[0]!='1':
            np=int(pages[0])
            perpage=int(re.findall('-t%i-(\\d+)\\.htm">2</a>'%topicid,pagedata)[0])
            for offset in range(1,np):
                progressline=statusline+"Downloading Extra Page %i of %i - "%(offset,np-1)
                pagedata+=download_page(URL+'-t%i-%i.htm'%(topicid,offset*perpage),progressline,COOKIEDATA)
        processed_data=pagedata
        cn=0
        for search,repl in re_repstrings:
            cn+=1
            printline(statusline+"Processing Step %i of %i"%(cn,len(re_repstrings)))
#           file("%i_%i.txt"%(topicid,cn),"w").write(processed_data)
            processed_data=re.sub(search,repl,processed_data)
        printline(statusline+"Converting Topic")
        forum,title=0,''
        posts=[] # will hold tuples of (time,id,userid,name,edittime,editname,data)
        '''   0      1         2         3           4           5      6      7           8           9            10             '''
        '''<^>POST<|>Post ID<|>User ID<|>User Name<|>Date/Time<|>Text<|>EDIT<|>Edit Name<|>Edit Time<|>Edit Count<|>Edit Reason</^>'''
        ''' 0    1  2      3    4        5        6    7         8'''
        '''(time,id,userid,name,edittime,editname,data,editcount,editreason)'''
        for line in processed_data.split('</^><^>'):
            ln=line.strip()
            if not ln: continue
            ln=ln.split('<|>')
            if ln[0]=='FORUM':
                forum=BOARDS[int(ln[1])]
                continue
            elif ln[0]=='TITLE' and not title:
                title=cgi.escape(ln[1])
                continue
            elif ln[0]=='POST':
                post=[0,0,0,'',0,0,'',0,'']
                if len(ln)==11:
                    if ln[6]=='EDIT':
                        post[4]=parsetime(ln[8])
                        post[5]=memberslist.get(ln[7],1)
                        post[7]=int(ln[9])
                        post[8]=ln[10]
                post[0]=parsetime(ln[4])
                post[1]=int(ln[1])
                if ln[2]: post[2]=int(ln[2])+1
                post[3]=ln[3]
                post_text=ln[5].strip()
                for search,repl in re_bbcode:
                    post_text=re.sub(search,repl,post_text)
                post[6]=parsespans(post_text)
                posts+=[post]
        if not posts:
            printline(statusline+"Error: Topic is empty!")
            print # a blank line, for the next topic
            continue
        posts.sort(key=lambda x:x[0]) # sort by date code only
        for i in range(len(posts)):
            posts[i][1]=postid
            postid+=1
        if forum not in forum_stats: forum_stats[forum]=(0,0,0,0)
        highestpost_id,highestpost_time=forum_stats[forum][2],forum_stats[forum][3]
        if posts[-1][0] > forum_stats[forum][3]: highestpost_id,highestpost_time=posts[-1][1],posts[-1][0]
        forum_stats[forum]=(forum_stats[forum][0]+1,forum_stats[forum][1]+len(posts),highestpost_id,highestpost_time)
        # change this for a different forum
        topicdata+=[(topicid,int(topicid in sticky),forum,posts[0][1],posts[0][3],posts[-1][1],posts[-1][2],posts[-1][3],title,posts[-1][0],posts[0][2],posts[0][0],title,len(posts)-1,len(posts)-1,topicviews.get(topicid,0),int(pagedata.find(img_locked)!=-1))]
        for post in posts:
            ''' 0    1  2      3    4        5        6    '''
            '''(time,id,userid,name,edittime,editname,data)'''
            # change this for a different forum
            bbcode_uid=''.join([random.choice('abcdefghijklmnopqrstuvwxyz0123456789') for __ in xrange(8)])
            bbcode_bitfield=makebitfield(post[6]).strip()
            post[6]=post[6].replace(":<UID>",":"+bbcode_uid).replace('<br />','\n')
            postdata+=[[post[1],topicid,forum,post[2],post[0],'',post[3],post[4],post[7],post[5],title,post[6],bbcode_uid,md5.new(post[6]).hexdigest(),bbcode_bitfield,post[8]]]
        printline(statusline+"Completed: %i post%s"%(len(posts),int(len(posts)!=1)*'s'))
        print # blank line for next topic
    except KeyboardInterrupt: break
    except Exception:
        do_except("Topic ID %i"%topicid, statusline)

out=open('topics_posts_phpBB3.sql','w')
out.write('DELETE FROM %stopics;DELETE FROM %stopics_posted;DELETE FROM %sposts;'%(table_prefix,table_prefix,table_prefix))
# change these two for a different forum
topicdata_vals=[escape_vars(i) for i in topicdata]
postdata=[escape_vars(i) for i in postdata]
for i in range(0,len(topicdata_vals),topics_max_group):
    out.write("INSERT INTO %stopics (topic_id,topic_type,forum_id,topic_first_post_id,topic_first_poster_name,topic_last_post_id,topic_last_poster_id,topic_last_poster_name,topic_last_post_subject,topic_last_post_time,topic_poster,topic_time,topic_title,topic_replies,topic_replies_real,topic_views,topic_status) VALUES "%table_prefix)
    out.write(','.join(["(%i,%i,%i,%i,'%s',%i,%i,'%s','%s',%i,%i,%i,'%s',%i,%i,%i,%i)"%tuple(td) for td in topicdata_vals[i:i+topics_max_group]]))
    out.write(";\n")
    out.write("INSERT INTO %stopics_posted (user_id, topic_id, topic_posted) VALUES "%table_prefix)
    out.write(','.join(','.join(["(%i, %i, 1)"%(k,td[0]) for k in set([p[3] for p in postdata if p[1]==td[0]])]) for td in topicdata_vals[i:i+topics_max_group]))
    out.write(";\n")
for i in range(0,len(postdata),posts_max_group):
    out.write("INSERT INTO %sposts (post_id,topic_id,forum_id,poster_id,post_time,poster_ip,post_username,post_edit_time,post_edit_count,post_edit_user,post_subject,post_text,bbcode_uid,post_checksum,bbcode_bitfield,post_edit_reason) VALUES "%table_prefix)
    out.write(','.join(["(%i,%i,%i,%i,%i,'%s','%s',%i,%i,%i,'%s','%s','%s','%s','%s','%s')"%tuple(pd) for pd in postdata[i:i+posts_max_group]]))
    out.write(";\n")
out.close()
print 'Elapsed Conversion Time %.02f seconds' % (time() - beg_time)
print 'Converted',len(postdata),'posts and',len(topicdata),'topics.'
raw_input("Complete! Press <enter> to exit.")
